package it.unipd.stat.se2.coda;

import java.util.NoSuchElementException;
import java.util.Iterator;

public class GenericDynamicQueue<E>
implements GenericQueue<E>//, java.util.RandomAccess non e' vero
{
	int numElem;
	NodoDoppio<E> head, tail;

	public GenericDynamicQueue()
	{
		numElem = 0;
		head = tail = null;
	}

	public boolean add(E o)
	{
		NodoDoppio<E> tmp = new NodoDoppio<E>(o);
		if(isEmpty())
		{
			head = tail = tmp;
		}
		else
		{
			tail.next = tmp;
			tmp.prev = tail;
			tail = tmp;//tail = tail.next;
		}
		numElem++;
		return true;
	}

	public boolean offer(E o)
	{
		return add(o);
	}

	public E peek()
	{
		if(isEmpty())
		{
			return null;
		}
		else
		{
			return head.contenuto;
		}
	}

	public E element()
	{
		if(isEmpty())
		{
			throw new java.util.NoSuchElementException("Coda vuota");
		}
		return head.contenuto;
	}

	public E remove()
	{
		if(isEmpty())
		{
			throw new java.util.NoSuchElementException("Coda vuota");
		}
		E retval = head.contenuto;
		numElem--;
		if(numElem==0)
		{
			head = tail = null;
		}
		else
		{
			head = head.next;
			head.prev.next = null;
			head.prev = null;
		}
		return retval;
	}

	public E poll()
	{
		if(isEmpty())
		{
			return null;
		}
		return remove();
	}

	public int size()
	{
		return numElem;
	}

	public boolean isEmpty()
	{
		return size() == 0;
	}

	public boolean isFull()
	{
		return false;
	}

	public java.util.Iterator<E> iterator()
	{
		//poi vediamo
		return new IteratoreGenericDynamicQueue<E>(this);
	}

	public String toString()
	{
		String retval = "[";
		Iterator<E> iter = iterator();
		boolean addComma = false;
		while(iter.hasNext())
		{
			if(addComma)
			{
				retval = retval.concat(", ");
			}
			else
			{
				addComma = true;
			}
			retval = retval.concat(String.valueOf(iter.next()));
		}
		retval = retval.concat("]");
		return retval;
	}

	class IteratoreGenericDynamicQueue<E>
	implements java.util.Iterator<E>
	{
		GenericDynamicQueue<E> c;
		NodoDoppio<E> cursore;
		int pos;
		boolean nextEseguita;

		IteratoreGenericDynamicQueue(GenericDynamicQueue<E> l)
		{
			c = l;
			cursore = c.head;
			pos = 0;
			nextEseguita = false;
		}

		public boolean hasNext()
		{
			return (cursore != null);
		}

		public E next()
		{
			if(!hasNext())
			{
				throw new NoSuchElementException();
			}
			E retval = cursore.contenuto;
			cursore = cursore.next;
			pos++;
			nextEseguita = true;
			return retval;
		}

		public void remove()
		{
			if(!nextEseguita)
			{
				throw new IllegalStateException();
			}
			nextEseguita = false;
			if(c.size() == 1)//tolgo la testa che e' anche la coda che e' anche tutto quello che c'e'
			{
				c.head = c.tail = null;
			}
			else if(pos == 1)
			{
				head.contenuto = null;
				cursore.prev = null;
				c.head.next = null;
				c.head = cursore;
			}
			else if(pos == c.size())
			{
				c.tail.contenuto = null;
				c.tail = c.tail.prev;
				c.tail.next.prev = null;
				c.tail.next = null;
			}
			else
			{
				NodoDoppio<E> tmp = cursore.prev;
				cursore.prev.prev.next = cursore;
				cursore.prev = cursore.prev.prev;
				tmp.contenuto = null;
				tmp.next = tmp.prev = null;
			}

			numElem--;
			pos--;
		}
	}
}
