package it.unipd.stat.se2.collections;

import java.util.*;
import java.io.*;

public class Studente
implements Comparable<Studente>
{
	String nome;
	String cognome;
	int matricola;
	List<EsameSuperato> esami;

	public Studente()
	{
		nome = cognome = null;
		matricola = -1;
		esami = new ArrayList<EsameSuperato>();
	}

	public int compareTo(Studente o)
	{
		//Studente s = (Studente)o; non serve se uso i generics
		return (matricola - o.matricola);
	}

	/**
	* Legge un file con formato fissato.
	* <Inizio Studente>
	* nome
	* cognome
	* matricola
	* 0 o piu' righe con la coppia nomeEsame,voto
	* <Fine Studente>
	*/
	public boolean popola(BufferedReader br)
	{
		String linea = null;
		try
		{
			linea = br.readLine();
			if(linea == null || !linea.equals("<Inizio Studente>"))
			{
				return false;
			}
			linea = br.readLine();
			if(linea == null)
			{
				return false;
			}
			//se ci fossero da fare dei controlli sul formato del nome andrebbero qui
			nome = linea;

			linea = br.readLine();
			if(linea == null)
			{
				return false;
			}
			//se ci fossero da fare dei controlli sul formato del cognome andrebbero qui
			cognome = linea;

			linea = br.readLine();;
			if(linea == null)
			{
				return false;
			}
			//se ci fossero da fare dei controlli sul formato della matricola andrebbero qui
			try
			{
				matricola = Integer.parseInt(linea);
			}
			catch(NumberFormatException nfe)
			{
				nfe.printStackTrace();
				return false;
			}

			while( (linea = br.readLine())!= null && !linea.equals("<Fine Studente>"))
			{
				EsameSuperato es = new EsameSuperato();
				StringTokenizer st = new StringTokenizer(linea, ",");
				if(st.hasMoreTokens())//abbiamo trovato il nome dell'esame
				{
					es.nomeEsame = st.nextToken().trim();
				}
				else
				{
					return false;
				}

				if(st.hasMoreTokens())//abbiamo trovato il voto
				{
					try
					{
						es.voto = Integer.parseInt(st.nextToken().trim());
					}
					catch(NumberFormatException nfe2)
					{
						nfe2.printStackTrace();
						return false;
					}
				}
				else
				{
					return false;
				}

				if(st.hasMoreTokens())//abbiamo trovato troppa roba
				{
					System.err.println("Stringa <" + linea + "> non accettabile come nomeEsame,voto");
					return false;
				}
				this.esami.add(es);
			}
			if(linea == null)
			{
				return false;
			}
			return true;
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return false;
		}
	}

	public String toString()
	{
		String retval = nome + " " + cognome + " " + matricola + ":";
		Iterator<EsameSuperato> iter = esami.iterator();
		while(iter.hasNext())
		{
			EsameSuperato es = iter.next();
			retval = retval.concat(es.nomeEsame + ", " + es.voto + ";");
		}
		return retval;
	}

	class EsameSuperato
	{
		String nomeEsame;
		int voto;
	}
}
