package it.unipd.stat.se2.ludoteca;

import java.util.*;
import java.io.*;

public class Ludoteca
{
	Map<Integer, List<Gioco>>giochiPerEta;
	Map<String, Comparator<Gioco>> comparatori;
	Scanner stdin;

	public Ludoteca()
	{
		giochiPerEta = new HashMap<Integer, List<Gioco>>();
		comparatori = new HashMap<String, Comparator<Gioco>>();

		stdin = new Scanner(System.in);

		comparatori.put("perNome", new ComparaGiochiPerNome());
		//comparatori.put("perAnno", new ComparaGiochiPerAnno());
		//comparatori.put("perCasaEditrice", new ComparaGiochiPerCasaEditrice());
		//comparatori.put("perCategoria", new ComparaGiochiPerCategoria());
		//comparatori.put("perEtaMinima", new ComparaGiochiPerEtaMinima());
	}

	public void ordina()
	{
		System.out.print("Ordinamento? " + comparatori.keySet() + " > ");
		String key = stdin.nextLine();
		ordinaEStampa(key);
	}

	public void leggi()
	{
		System.out.print("Nome file? > ");
		String nomeFile = stdin.nextLine();
		Scanner sc = null;
		try
		{
			sc = new Scanner(new File(nomeFile));
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			return;
		}
		while(true)
		{
			Gioco g = new Gioco();
			if(g.popola(sc))
			{
				List<Gioco> l = giochiPerEta.get(g.etaMinima);
				if(l == null)
				{
					l = new LinkedList<Gioco>();
					giochiPerEta.put(g.etaMinima, l);
				}
				l.add(g);
			}
			else
			{
				break;
			}
		}
		sc.close();
	}

	public void elenco()
	{
		ordinaEStampa("perNome");
	}

	public void ordinaEStampa(String key)
	{
		Comparator<Gioco> comp = comparatori.get(key);
		if(comp == null)
		{
			System.out.println("Non conosco l'ordinamento <" + key + ">");
			return;
		}
		List<Gioco> l = new LinkedList<Gioco>();
		Collection<List<Gioco>> c = giochiPerEta.values();
		Iterator<List<Gioco>> iter = c.iterator();
		while(iter.hasNext())
		{
			l.addAll(iter.next());
		}
		Collections.sort(l, comp);
		System.out.println(l);
	}

}
